# ベクトルとベクトルの積（テキスト、式(2.28)）
a <- rbind(c(1, 2, 3)) # 行ベクトルを作成

b <- rbind(c(4),
           c(5),
           c(6)) # 列ベクトルを作成する

# ベクトルとベクトルの積を計算する。
a %*% b


# 行列とベクトルの積（テキスト、式(2.34)）
A <- rbind(c(1, 2, 3), 
           c(4, 5, 6),
           c(7, 8, 9)) # 行列を作成

b <- rbind(c(1),
           c(2),
           c(3)) # 列ベクトルを作成する

# ベクトルとベクトルの積を計算する。
A %*% b


# 行列と行列の積（テキスト、式(2.38)）
A <- rbind(c(1, 2), 
           c(3, 4)) # 行列を作成

B <- rbind(c(5, 6), 
           c(7, 8)) # 行列を作成

# ベクトルとベクトルの積を計算する。
A %*% B


# 式(2.47)の離接行列
mynetmatrix <- rbind(c(0, 1, 1, 0),
                     c(0, 0, 1, 1),
                     c(1, 1, 0, 0),
                     c(1, 0, 0, 0))
# snaを読み込む
library(sna)

# ネットワークのグラフ(隣接行列から直接描くこともできる)（図(2.32)）
# ここではネットワークオブジェクトを作らず描画する。
gplot(mynetmatrix, gmode = "digraph", label =c(1, 2, 3, 4))

# 2乗の各要素の確認
mynetmatrix %*% mynetmatrix

# 3乗の各要素の確認(式(2.48))
mynetmatrix %*% mynetmatrix %*% mynetmatrix

# 4乗の各要素の確認
mynetmatrix %*% mynetmatrix %*% mynetmatrix %*% mynetmatrix


