#############
# 3.5節で示したスクリプト

#ネットワーク
mynet <- matrix(c(
  0,1,1,1,
  1,0,1,0,
  1,1,0,0,
  0,0,1,0),
  nrow = 4,
  byrow = TRUE)


# 相互性の導出 (snaを用いる)
library(sna)
grecip(mynet, measure = "dyadic.nonnull")



# 推移性の導出 (snaを用いる)
gtrans(mynet, mode="digraph") #オプションを明示している




# クラスター係数を求める

detach(package:sna)

##################
#igraphでの分析
library(igraph)

# igraphでは無向ネットワークで推移性を考えるので、
# 無向ネットワークをあらためて作る。
mynet.nd <- matrix(c(
  0,1,1,1,
  1,0,1,0,
  1,1,0,1,
  1,0,1,0),
  nrow = 4,
  byrow = TRUE)

# igraphでは無向ネットワークのグラフオブジェクトを作る。
mynetg.nd <- graph_from_adjacency_matrix(mynet.nd, mode="undirected")


# 各ノードのコマンドでクラスター係数を求める。
transitivity(mynetg.nd, type="local")

# ノード別のクラスター係数の平均値をとり、
# ネットワーク全体のクラスター係数とする。

mean(transitivity(mynetg.nd, type="local"))


